     /*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.evasion.client.controler.booktravel;

import com.evasion.client.controler.ApplicationContext;
import com.evasion.common.Constante;
import com.evasion.common.Utils;
import com.evasion.entity.booktravel.BookTravel;
import com.evasion.entity.booktravel.RoadMap;
import com.evasion.entity.booktravel.exception.BookTravelServiceException;
import com.evasion.entity.content.Comment;
import com.evasion.exception.EvasionException;
import com.evasion.module.travel.ITravelModule;
import java.io.IOException;
import java.io.Serializable;
import java.util.Map;
import java.util.logging.Level;
import javax.annotation.PostConstruct;
import javax.ejb.EJB;
import javax.faces.bean.ManagedBean;
import javax.faces.bean.ManagedProperty;
import javax.faces.bean.RequestScoped;
import javax.faces.component.UICommand;
import javax.faces.component.html.HtmlPanelGroup;
import javax.faces.context.ExternalContext;
import javax.faces.context.FacesContext;
import javax.mail.Session;
import javax.servlet.RequestDispatcher;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/**
 *
 * @author sebastien
 */
@ManagedBean
@RequestScoped
public class RoadmapView implements Serializable {

    /**
     * *
     * serialVersionUID.
     */
    private static final long serialVersionUID = 1L;

    /**
     * LOGGER.
     */
    private static final Logger LOGGER = LoggerFactory.getLogger(
            RoadmapView.class);

    @EJB
    private ITravelModule bookTravelEJB;

    @ManagedProperty(name = "", value = "#{applicationContext}")
    private ApplicationContext applicationContext;

    private Comment commentaireNew = new Comment();

    private Long idRoadMap;

    private RoadMap roadMap;

    private HtmlPanelGroup panelAjout;

    private UICommand lienAjout;

    @PostConstruct
    public void init() throws Exception {
        LOGGER.debug("Init de la page d'index d'un bookTravel");
        final Map params = FacesContext.getCurrentInstance().
                getExternalContext().getRequestParameterMap();
        String id = (String) params.get("id");
        String idFormulaire = (String) params.get("idRoadMap");

        if (!Utils.isEmpty(idFormulaire) && idRoadMap == null) {
            idRoadMap = Long.parseLong(idFormulaire);
        } else if (!Utils.isEmpty(id) && idRoadMap == null) {

            idRoadMap = Long.parseLong(id);
        }
        if (idRoadMap != null) {
            try {
                // Force la récupération de la feuille de route.
                this.roadMap = bookTravelEJB.findRoadMapById(this.idRoadMap);
                FacesContext.getCurrentInstance().
                        getExternalContext().getSessionMap().put("currentBookTravelID", this.roadMap.getBookTravel().getId());
            } catch (BookTravelServiceException ex) {
                java.util.logging.Logger.getLogger(RoadmapView.class.getName()).log(Level.SEVERE, null, ex);
            }
        }
    }

    /**
     * Affiche le panel d'ajout d'un commentaire.
     *
     * @return
     * <code>Constante.SUCCESS_ACTION</code>;
     */
    public String viewPanelAjout() throws EvasionException {


        if (applicationContext.getPrincipal() == null) {

            FacesContext ctx = FacesContext.getCurrentInstance();
            ExternalContext ectx = ctx.getExternalContext();
            HttpServletRequest request = (HttpServletRequest) ectx.getRequest();
            HttpServletResponse response = (HttpServletResponse) ectx.getResponse();
            StringBuilder sb = new StringBuilder(request.getRequestURI());
            sb.append('?');
            sb.append("id=").append(roadMap.getId());

            request.getSession().setAttribute("javax.security.evasion.SavedRequestURL", sb.toString());
            response.setHeader("Location", response.encodeRedirectURL(request.getContextPath() + "/login.xhtml"));
            response.setStatus(HttpServletResponse.SC_TEMPORARY_REDIRECT);

            return Constante.SUCCESS_ACTION;

        }
        lienAjout.setRendered(false);
        panelAjout.setRendered(true);
        // Force la récupération de la feuille de route.
        this.getRoadMap();

        return Constante.SUCCESS_ACTION;
    }

    /**
     *
     * @return
     * <code>Constante.SUCCESS_ACTION</code>;
     */
    public final String annulAjout() {
        lienAjout.setRendered(true);
        panelAjout.setRendered(false);
        // Force la récupération de la feuille de route.
        this.roadMap = null;
        return Constante.SUCCESS_ACTION;
    }

    /**
     *
     * @return
     * <code>Constante.SUCCESS_ACTION</code>;
     */
    public final String validerAjout() throws EvasionException {
        lienAjout.setRendered(true);
        panelAjout.setRendered(false);
        //  roadMap.getContribution().getId();
        bookTravelEJB.createCommentOnRoadMap(this.getRoadMap(), commentaireNew);
        return Constante.SUCCESS_ACTION;
    }

    /**
     * Renvoi la feuille de route.
     *
     * @return feuille de route.
     */
    public RoadMap getRoadMap() {
        return this.roadMap;
    }

    /**
     * Renvoi le lien d'ajout d'un commentaire.
     *
     * @return lien d'ajout d'un commentaire;
     */
    public UICommand getLienAjout() {
        return lienAjout;
    }

    public void setLienAjout(UICommand lienAjout) {
        this.lienAjout = lienAjout;
    }

    /**
     * Renvoi de panel d'ajout.
     *
     * @return panel d'ajout;
     */
    public final HtmlPanelGroup getPanelAjout() {
        return panelAjout;
    }

    /**
     * Setter du panel d'ajout.
     *
     * @param panelAjout panel d'ajout;
     */
    public final void setPanelAjout(HtmlPanelGroup panelAjout) {
        this.panelAjout = panelAjout;
    }

    public Long getIdRoadMap() {
        return idRoadMap;
    }

    public void setIdRoadMap(Long idRoadMap) {
        this.idRoadMap = idRoadMap;
    }

    public Comment getCommentaireNew() {
        return commentaireNew;
    }

    public void setCommentaireNew(Comment commentaireNew) {
        this.commentaireNew = commentaireNew;
    }

    public ApplicationContext getApplicationContext() {
        return applicationContext;
    }

    public void setApplicationContext(ApplicationContext applicationContext) {
        this.applicationContext = applicationContext;
    }
}
